﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace ControlContainerTestApp
{
    public partial class BattingAvgControl : UserControl
    {
        public event ValueChangedEventHandler ValueChanged;
        public BattingAvgControl()
        {
            InitializeComponent();
        }

        [Browsable(true)]
        [DefaultValue("[Custom Control]")]
        public string LabelText
        {
            get;
            set;
        }

        private decimal _battingAverage;
        [Bindable(BindableSupport.Yes)]
        public decimal Value
        {
            get
            {
                return _battingAverage;
            }
            set
            {
                _battingAverage = value;

                this.battingAverageTextBox.Text = _battingAverage.ToString();
                OnValueChanged();
            }
        }

        private void OnValueChanged()
        {
            if (ValueChanged != null)
            {
                ValueChanged(this, new EventArgs());
            }
        }

        private void battingAverageTextBox_TextChanged(object sender, EventArgs e)
        {
            Value = Decimal.Parse(battingAverageTextBox.Text.Trim());
        }

        private void BattingAvgControl_Load(object sender, EventArgs e)
        {
            this.titleLabel.Text = LabelText;
        }
    }

    public delegate void ValueChangedEventHandler(object sender, EventArgs e);
}
